-- By dominiczeth
-- Thanks to BBeutlin @ GDN!
-- Version 1.2

--[[
Filltype 30 = hay
Filltype 24 = Silage 
Filltype 28 = grass
Filltype 31 = straw
Filltype 11 = cotton]]

local hay       = 2.2     --Dies sind die Multiplikatoren für die einzelnen Filltypes. Der Multiplikator bei "other" ist für alle Filltypes die noch nicht im Spiel vorhanden sind. 
local silage    = 1.7
local grass     = 1.5
local straw     = 2
local cotton    = 1
local other     = 1





function UnloadTrigger:updateBales(dt)
    for index, bale in ipairs(self.balesInTrigger) do
        if bale ~= nil and bale.nodeId ~= 0 then
            if bale.dynamicMountJointIndex == nil then
                local fillType = bale:getFillType()
                --print("Filltyp" .. fillType)
                local multiplicator = 1
                if fillType == 11 then
                    multiplicator = cotton
                    elseif fillType == 30 then
                    multiplicator = hay
                    elseif fillType == 24 then
                    multiplicator = silage
                    elseif fillType == 28 then
                    multiplicator = grass
                    elseif fillType == 31 then
                    multiplicator = straw
                else
                    multiplicator = other
                end
                local multiPrint = multiplicator
                --print("multiplikator = " .. multiPrint)
                local fillLevel = bale:getFillLevel() * multiplicator
                --print("First Filllevel= ".. fillLevel)
                local fillInfo = nil
                local delta = bale:getFillLevel() * multiplicator
                if self.baleDeleteLitersPerMS ~= nil then
                    delta = self.baleDeleteLitersPerMS * dt
                end
                if delta > 0 then
                    self.target:addFillLevelFromTool(bale:getOwnerFarmId(), delta, fillType, fillInfo, ToolType.BALE)
                    bale:setFillLevel(fillLevel - delta)
                    local newFillLevel = bale:getFillLevel() * multiplicator
                    --print("Ballenvolumen" .. newFillLevel)
                    --print("Delta".. delta)
                    --print("dt Value".. dt)
                    if newFillLevel < 0.5 then                            --if newFillLevel < 0.01 then
                        bale:delete()
                        table.remove(self.balesInTrigger, index)
                        break
                    end
                end
            end
        else
            table.remove(self.balesInTrigger, index)
        end
    end
    if #self.balesInTrigger > 0 then
        self:raiseActive()
    end
end

